
namespace InterpolationTest
{
    public struct Vector2D
    {
        public double X;
        public double Y;

        public Vector2D(double x, double y)
        {
            X = x;
            Y = y;
        }

        public static Vector2D operator *(float left, Vector2D right)
        {
            return new Vector2D(left * right.X, left * right.Y);
        }
        public static Vector2D operator *(Vector2D left, float right)
        {
            return new Vector2D(left.X * right, left.Y * right);
        }
        public static Vector2D operator *(double left, Vector2D right)
        {
            return new Vector2D(left * right.X, left * right.Y);
        }
        public static Vector2D operator *(Vector2D left, double right)
        {
            return new Vector2D(left.X * right, left.Y * right);
        }

        public static Vector2D operator +(float left, Vector2D right)
        {
            return new Vector2D(left + right.X, left + right.Y);
        }
        public static Vector2D operator +(Vector2D left, float right)
        {
            return new Vector2D(left.X + right, left.Y + right);
        }
        public static Vector2D operator +(double left, Vector2D right)
        {
            return new Vector2D(left + right.X, left + right.Y);
        }
        public static Vector2D operator +(Vector2D left, double right)
        {
            return new Vector2D(left.X + right, left.Y + right);
        }

        public static Vector2D operator +(Vector2D left, Vector2D right)
        {
            return new Vector2D(left.X + right.X, left.Y + right.Y);
        }
        public static Vector2D operator -(Vector2D left, Vector2D right)
        {
            return new Vector2D(left.X - right.X, left.Y - right.Y);
        }

        public override string ToString()
        {
            return "<" + X + " ; " + Y + ">";

        }
    }
}